package com.sun.xml.internal.stream;

import com.sun.org.apache.xerces.internal.xni.parser.XMLInputSource;
import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLStreamReader;
import java.io.InputStream;
import java.io.IOException;
import javax.xml.stream.XMLStreamException;
import com.sun.org.apache.xerces.internal.xni.XNIException;
import com.sun.org.apache.xerces.internal.xni.XMLResourceIdentifier;
import javax.xml.stream.XMLResolver;

public class StaxEntityResolverWrapper
{
    XMLResolver fStaxResolver;
    
    public StaxEntityResolverWrapper(XMLResolver resolver) {
        this.fStaxResolver = resolver;
    }
    
    public void setStaxEntityResolver(XMLResolver resolver) {
        this.fStaxResolver = resolver;
    }
    
    public XMLResolver getStaxEntityResolver() {
        return this.fStaxResolver;
    }
    
    public StaxXMLInputSource resolveEntity(XMLResourceIdentifier resourceIdentifier) throws XNIException, IOException {
        Object object = null;
        try {
            object = this.fStaxResolver.resolveEntity(resourceIdentifier.getPublicId(), resourceIdentifier.getLiteralSystemId(), resourceIdentifier.getBaseSystemId(), null);
            return this.getStaxInputSource(object);
        }
        catch (XMLStreamException streamException) {
            throw new XNIException(streamException);
        }
    }
    
    StaxXMLInputSource getStaxInputSource(Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof InputStream)) {
            return new StaxXMLInputSource(new XMLInputSource(null, null, null, (InputStream)object, null));
        }
        if ((object instanceof XMLStreamReader)) {
            return new StaxXMLInputSource((XMLStreamReader)object);
        }
        if ((object instanceof XMLEventReader)) {
            return new StaxXMLInputSource((XMLEventReader)object);
        }
        return null;
    }
}
